package tcp;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.logging.Level;
import java.util.logging.Logger;


/**
 *
 * @author votavon1
 */
public class Server extends Thread {
    private Socket s;
    public static void main(String[] args) {
        System.out.println("Server started ...");
        ServerSocket ss = null;
        try {
            ss = new ServerSocket(50010);
            while(true){
                Socket s = ss.accept();
                Server srv = new Server();
                srv.s = s;
                srv.start();
            }
        } catch (IOException ex) {
            Logger.getLogger(Server.class.getName()).log(Level.SEVERE, null, ex);
        } finally {
            try{
                ss.close();
            } catch (IOException ex) {
                Logger.getLogger(Server.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }
    
    @Override
    public void run(){
        InputStream is = null;
        OutputStream os = null;
        try {            
            is = s.getInputStream();
            os = s.getOutputStream();
            int state = 0;
            int c;
            while((c = is.read())!=-1){
                switch(state){
                    case 0:
                    case 1:
                        switch(c){
                            case 'a':
                                state = 1;
                                os.write("state = 1\n".getBytes());
                                break;
                            case 'b':
                                state = 2;
                                os.write("state = 2\n".getBytes());
                                break;
                            default:
                                os.write("Chybny znak\n".getBytes());
                        }
                        break;
                    case 2:
                        switch(c){
                            case 'a':
                            case 'b':
                                os.write("state = 2\n".getBytes());
                                break;
                            default:
                                os.write("Chybny znak\n".getBytes());
                        }
                        break;
                    default:
                        System.out.println("Chybny stav");
                }
            }
            System.out.println("Klient se odpojil");
            System.out.println("Stav je "+state);
            
        } catch (IOException ex) {
            Logger.getLogger(Server.class.getName()).log(Level.SEVERE, null, ex);
        } finally{
            try {
                s.close();
            } catch (IOException ex) {
                Logger.getLogger(Server.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }
}
